--[[
	DuckMod - A World of Warcraft add-on library
	Copyright (C) 2009-2012  Dag Bakken

	DuckMod is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	DuckMod is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with DuckMod.  If not, see <http://www.gnu.org/licenses/>.
]]


local TV=3.1;

if (not DuckMod) then DuckMod = {}; end			-- Make it if empty
if (not DuckMod[TV]) then					-- Don't mess with it if it's loaded
	DuckMod[TV]={};
end
local DM=DuckMod[TV];
local _;


DM.Server={
	Address={			-- served addresses
	},
};

local wn=DM.WoWnet;
local srv=DM.Server;
local add=srv.Address;


-- Set up for handling
function srv:Init()
--	if (not self.TheFrame) then
--		self.TheFrame=CreateFrame("Frame","DuckMod-BrowserServer-Messager"..TV,UIParent);
--		if (not self.TheFrame) then DM:Chat("Could not create DuckMod BrowserServer UI frame",1); return; end
--	end
--	if (not self.TheFrameWorldMap) then
--		self.TheFrameWorldMap=CreateFrame("Frame","DuckMod-BrowserServerWM-Messager"..TV,WorldMapDetailFrame);
--		if (not self.TheFrameWorldMap) then DM:Chat("Could not create DuckMod BrowserServer WM frame",1); return; end
--	end
--	self.TheFrame:SetScript("OnUpdate",self.Tick);
--	self.TheFrameWorldMap:SetScript("OnUpdate",self.Tick);

	wn:Connect();
end


-- incoming data to an address/protocol pair
function srv.Incoming(listen,sender,data,fnReply)
	if (not add[listen.address] and not add[listen.address][listen.protocol]) then return; end
	data.location=data.location or "";
	data.name=data.name or "index";
	if (data.location:sub(1,1)=="/") then data.location=data.location:sub(2); end
	data.location=strtrim(data.location:lower());
	data.name=strtrim(data.name:lower()); if (data.name:len()<1) then return nil; end
	-- get root
	local ptr=add[listen.address][listen.protocol];
	-- find location
	if (data.location~="") then
		local buf={strsplit("/",data.location)};
		for _,dir in ipairs(buf) do
			if (dir~="") then
				if (not ptr[dir]) then ptr[dir]={}; end
				ptr=ptr[dir];
			end
		end
	end
	if (ptr[data.name] and ptr[data.name].Data) then fnReply(ptr[data.name].Data); end
end

-- boot up a server
function srv:Boot(address,protocol,description)
	if (not add[address] or not add[address][protocol]) then
		if (not add[address]) then add[address]={}; end					-- new server
		add[address][protocol]={										-- new protocol
			_listen=wn:Listen(address,protocol,srv.Incoming,description);
		};
	end
	return add[address][protocol];
end

-- shut down a server
function srv:Shutdown(address,protocol)
	if (not add[address]) then return; end
	if (protocol) then
		if (not add[address][protocol]) then return; end
		add[address][protocol]._listen:Close();							-- shut down all interfaces
		wipe(add[address][protocol]); add[address][protocol]=nil;
		if (next(add[address])) then return; end
	end
	wipe(add[address]); add[address]=nil;
end

-- add a page to the server
function srv:AddPage(address,location,name,data,protocol,description)
	location=location or "";
	name=name or "index";
	protocol=protocol or "browser";
	if (location:sub(1,1)=="/") then location=location:sub(2); end		-- remove prefixed "/"
	location=strtrim(location:lower());
	name=strtrim(name:lower()); if (name:len()<1) then return nil; end	-- no empty string allowed
	-- create server
	local ptr=srv:Boot(address,protocol,description);
	-- add page at location
	if (location~="") then
		local buf={strsplit("/",location)};
		for _,dir in ipairs(buf) do
			if (not ptr[dir]) then ptr[dir]={}; end
			ptr=ptr[dir];
		end
	end
	ptr[name]={ Data=data, };
	return true;
end


