local addon = MessageBoard
local addonName = "MessageBoard"
local L = addon.L
local ldb = LibStub:GetLibrary("LibDataBroker-1.1", true)
if not ldb then return end

local plugin = ldb:NewDataObject("MessageBoard", {
	type = "data source",
	text = "0",
	icon = "Interface\\Buttons\\UI-GuildButton-PublicNote-Disabled",
})

function plugin.OnClick(self, button)
	if button == "RightButton" then
		InterfaceOptionsFrame_OpenToCategory(addonName)
		InterfaceOptionsFrame_OpenToCategory(addonName)
	else
		if MessageBoard_Main:IsShown() then
			MessageBoard_Main:Hide()
		else
			MessageBoard_Main:Show()
		end
	end
end

hooksecurefunc(MessageBoardXML, "UpdateDisplay", function()
	local count = MessageBoardXML:GetNewMsgCount() or 0
	if count > 0 then
		plugin.text = count
		plugin.icon = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up"
	else
		plugin.text = "0"
		plugin.icon = "Interface\\Buttons\\UI-GuildButton-PublicNote-Disabled"
	end
end)

do
	local hint = "|cffeda55fClick|r to open MessageBoard."
	function plugin.OnTooltipShow(tt)
		local count = MessageBoardXML:GetNewMsgCount() or 0
		if count == 0 then
			tt:AddLine("MessageBoard")
			tt:AddLine(" ")
			tt:AddLine("No new posts.", 0.2, 1, 0.2, 1)
		else
			tt:AddLine("MessageBoard")
			tt:AddLine(" ")
				if count == 1 then
					tt:AddLine(count.." new message.", 0.2, 1, 0.2, 1)
				else 
					tt:AddLine(count.." new messages.", 0.2, 1, 0.2, 1)
				end
		end
		tt:AddLine(" ")
		tt:AddLine(hint, 0.2, 1, 0.2, 1)
	end
end

local f = CreateFrame("Frame")
f:SetScript("OnEvent", function()
	local icon = LibStub("LibDBIcon-1.0", true)
	if not icon then return end
	if not MessageBoardLDBIconDB then MessageBoardLDBIconDB = {} end
	icon:Register("MessageBoard", plugin, MessageBoardLDBIconDB)
end)
f:RegisterEvent("PLAYER_LOGIN")